3 # Copyright (C) 1996, 1997, 1998 Free Software Foundation, Inc.
4 # This file is part of the GNU C Library.
6 # The GNU C Library is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU Library General Public License as
8 # published by the Free Software Foundation; either version 2 of the
9 # License, or (at your option) any later version.
11 # The GNU C Library is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14 # Library General Public License for more details.
16 # You should have received a copy of the GNU Library General Public
17 # License along with the GNU C Library; see the file COPYING.LIB. If not,
18 # write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
19 # Boston, MA 02111-1307, USA.
22 # This is the `ldd' command, which lists what shared libraries are
23 # used by given dynamically-linked executables. It works by invoking the
24 # run-time dynamic linker as a command and setting the environment
25 # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
27 # We should be able to find the translation right at the beginning.
29 TEXTDOMAINDIR
=@TEXTDOMAINDIR@
36 while test $# -gt 0; do
38 --vers |
--versi |
--versio |
--version)
39 echo 'ldd (GNU libc) @VERSION@'
40 echo $
"Copyright (C) 1996, 1997, 1998 Free Software Foundation, Inc.
41 This is free software; see the source for copying conditions. There is NO
42 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
43 Written by Roland McGrath and Ulrich Drepper."
46 --h |
--he |
--hel |
--help)
47 echo $
"ldd [OPTION]... FILE...
48 --help print this help and exit
49 --version print version information and exit
50 -d, --data-relocs process data relocations
51 -r, --function-relocs process data and function relocations
52 -v, --verbose print all information
53 Report bugs using the \`glibcbug' script to <bugs@gnu.org>."
56 -d |
--d |
--da |
--dat |
--data |
--data- |
--data-r |
--data-re | \
57 --data-rel |
--data-relo |
--data-reloc |
--data-relocs)
61 -r |
--f |
--fu |
--fun |
--func |
--funct |
--functi |
--functio | \
62 --function |
--function- |
--function-r |
--function-re |
--function-rel | \
63 --function-relo |
--function-reloc |
--function-relocs)
68 -v |
--verb |
--verbo |
--verbos |
--verbose)
73 echo >&2 $
"ldd: option \`$1' is ambiguous"
76 --) # Stop option processing.
80 echo >&2 'ldd:' $
"unrecognized option" "\`$1'"
81 echo >&2 $
"Try \`ldd --help' for more information."
92 # Maybe extra code for non-ELF binaries.
96 add_env
="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
97 add_env
="$add_env LD_VERBOSE=$verbose"
100 echo >&2 'ldd:' $
"missing file arguments"
101 echo >&2 $
"Try \`ldd --help' for more information."
105 # We don't list the file name when there is only one.
112 if test ! -f "$file"; then
113 echo "ldd: ${file}:" $
"no such file"
115 elif test -r "$file"; then
118 warning: you do not have execution permission for" "\`$file'" >&2
119 verify_out
=`${RTLD} --verify "$file"`
122 eval $add_env exec '"$file"' ||
exit 1
125 # This can be a non-ELF binary or no binary at all.
127 echo $
" not a dynamic executable"
131 eval $add_env exec \
${RTLD} '"$file"' ||
exit 1
134 echo 'ldd:' ${RTLD} $
"exited with unknown exit code" "($?)" >&2
139 echo 'ldd:' $
"error: you do not have read permission for" "\`$file'" >&2
154 if test ! -f "$file"; then
155 echo "ldd: ${file}:" $
"no such file"
157 elif test -r "$file"; then
158 test -x "$file" ||
echo 'ldd:' $
"\
159 warning: you do not have execution permission for" "\`$file'" >&2
160 verify_out
=`${RTLD} --verify "$file"`
163 eval $add_env '"$file"' || result
=1
166 # This can be a non-ELF binary or no binary at all.
168 echo $
" not a dynamic executable"
173 eval $add_env ${RTLD} '"$file"' || result
=1
176 echo 'ldd:' ${RTLD} $
"exited with unknown exit code" "($?)" >&2
181 echo 'ldd:' $
"error: you do not have read permission for" "\`$file'" >&2